/*
 * (C) Copyright IBM Corp. 2003
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   Konrad Rzeszutek <konradr@us.ibm.com>
 *
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.arrkay-user.conf,v 5.15.2.1 2003/02/27 05:59:41 rstory Exp $
 *
 * $Id: saHpiInventoryTable.h,v 1.6 2004/02/23 21:18:02 konradrzeszutek Exp $
 *
 */
#ifndef SAHPIINVENTORYTABLE_H
#define SAHPIINVENTORYTABLE_H

#ifdef __cplusplus
extern "C"
{
#endif

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/library/container.h>
#include <net-snmp/agent/table_array.h>
#include <SaHpi.h>

  /*
   * Number of index values in this table.
   * Consult the HPI-MIB
   *
   * If this number changes, look in the src code for this 
   * define, and make sure to add/remove the new index value(s).
   */
#define INVENTORY_INDEX_NR 4
  /*
   * Max values of saHpiInventoryAttributes. In the MIB its set to 255, but
   * the SAF spec uses 'Variable length opaque data' - which can mean
   * pretty much anything. We set the limit to 1000.
   */

#define SAHPI_INVENTORY_ATTRIBUTES_MAX 1000

  /*
   * Max length of Manufacturer, ProductName, ProductVersion, etc ..
   */
#define SAHPI_STRING_MAX 255

  /* 
   * Numerical values for saHpiInventoryValidity as defined per HPI-MIB
   */
#define MIB_UNDEFINED 0
#define MIB_VALID 1
#define MIB_INVALID 2
#define MIB_OVERFLOW 3

  /*
   * Number of SaHpiTextBufferT pointers in the SaHpiInventDataRecordT
   */
#define TEXT_BUFFER_NUMBER 9


  /*
   * Max number of fields the SaHpiInventoryAttributes can have
   * per different type of data.
   */
#define SAHPI_INVENT_RECTYPE_INTERNAL_USE_MAX 1000
#define SAHPI_INVENT_RECTYPE_CHASSIS_INFO_MAX 12
#define SAHPI_INVENT_RECTYPE_BOARD_INFO_MAX 8
#define SAHPI_INVENT_RECTYPE_PRODUCT_INFO_MAX 8
#define SAHPI_INVENT_RECTYPE_OEM_MAX 260
#define SAHPI_INVENT_RECTYPE_OEM_MIN 4

  typedef struct saHpiInventoryTable_context_s
  {
    netsnmp_index index;

	/** UNSIGNED32 = ASN_UNSIGNED */
    unsigned long saHpiInventoryEirId;
      /** UNSIGNED32 */
    unsigned long saHpiInventoryIndex;

	/** INTEGER = ASN_INTEGER */
    long saHpiInventoryRecordType;

	/** INTEGER = ASN_INTEGER */
    long saHpiInventoryValidity;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char saHpiInventoryAttributes[SAHPI_INVENTORY_ATTRIBUTES_MAX];
    long saHpiInventoryAttributes_len;

	/** INTEGER = ASN_INTEGER */
    long saHpiInventoryTextType;

	/** INTEGER = ASN_INTEGER */
    long saHpiInventoryTextLanguage;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char saHpiInventoryManufacturer[SAHPI_STRING_MAX];
    long saHpiInventoryManufacturer_len;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char saHpiInventoryProductName[SAHPI_STRING_MAX];
    long saHpiInventoryProductName_len;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char saHpiInventoryProductVersion[SAHPI_STRING_MAX];
    long saHpiInventoryProductVersion_len;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char saHpiInventoryModelNumber[SAHPI_STRING_MAX];
    long saHpiInventoryModelNumber_len;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char saHpiInventorySerialNumber[SAHPI_STRING_MAX];
    long saHpiInventorySerialNumber_len;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char saHpiInventoryPartNumber[SAHPI_STRING_MAX];
    long saHpiInventoryPartNumber_len;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char saHpiInventoryFileId[SAHPI_STRING_MAX];
    long saHpiInventoryFileId_len;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char saHpiInventoryAssetTag[SAHPI_STRING_MAX];
    long saHpiInventoryAssetTag_len;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char saHpiInventoryCustomField[SAHPI_STRING_MAX];
    long saHpiInventoryCustomField_len;

      /** UNSIGNED32 */
    unsigned long saHpiInventoryOEM;
	/** RowPointer = ASN_OBJECT_ID */
    oid saHpiInventoryRDR[MAX_OID_LEN];
    long saHpiInventoryRDR_len;

    long domain_id;
    long resource_id;
    long rdr_id;
    long hash;

    long count_of_subitems;
  } saHpiInventoryTable_context;

/*************************************************************
 * function declarations
 */

  void initialize_table_saHpiInventoryTable (void);


  int saHpiInventoryTable_get_value (netsnmp_request_info *,
				     netsnmp_index *,
				     netsnmp_table_request_info *);

  int populate_inventory (SaHpiEntryIdT rdr_id,
		  	  SaHpiInventoryRecT * control,
			  SaHpiRptEntryT * rpt_entry,
			  oid * rdr_oid, size_t rdr_oid_len,
			  oid * control_oid, size_t * control_oid_len);
  int
    delete_inventory_rows (SaHpiDomainIdT domain_id,
			   SaHpiResourceIdT resource_id, SaHpiEirIdT num);

  int set_inventory (saHpiInventoryTable_context * ctx);


/*************************************************************
 * oid declarations
 */
//    extern oid      saHpiInventoryTable_oid[];
//    extern size_t   saHpiInventoryTable_oid_len;

#define saHpiInventoryTable_TABLE_OID hpiResources_OID,9

/*************************************************************
 * column number definitions for table saHpiInventoryTable
 */

#define COLUMN_SAHPIINVENTORYEIRID 1
#define COLUMN_SAHPIINVENTORYINDEX 2
#define COLUMN_SAHPIINVENTORYRECORDTYPE 3
#define COLUMN_SAHPIINVENTORYVALIDITY 4
#define COLUMN_SAHPIINVENTORYATTRIBUTES 5
#define COLUMN_SAHPIINVENTORYTEXTTYPE 6
#define COLUMN_SAHPIINVENTORYTEXTLANGUAGE 7
#define COLUMN_SAHPIINVENTORYMANUFACTURER 8
#define COLUMN_SAHPIINVENTORYPRODUCTNAME 9
#define COLUMN_SAHPIINVENTORYPRODUCTVERSION 10
#define COLUMN_SAHPIINVENTORYMODELNUMBER 11
#define COLUMN_SAHPIINVENTORYSERIALNUMBER 12
#define COLUMN_SAHPIINVENTORYPARTNUMBER 13
#define COLUMN_SAHPIINVENTORYFILEID 14
#define COLUMN_SAHPIINVENTORYASSETTAG 15
#define COLUMN_SAHPIINVENTORYCUSTOMFIELD 16
#define COLUMN_SAHPIINVENTORYOEM 17
#define COLUMN_SAHPIINVENTORYRDR 18
#define saHpiInventoryTable_COL_MIN 1
#define saHpiInventoryTable_COL_MAX 18



  int
    saHpiInventoryTable_extract_index (saHpiInventoryTable_context *
				       ctx, netsnmp_index * hdr);

  void saHpiInventoryTable_set_reserve1 (netsnmp_request_group *);
  void saHpiInventoryTable_set_reserve2 (netsnmp_request_group *);
  void saHpiInventoryTable_set_action (netsnmp_request_group *);
  void saHpiInventoryTable_set_commit (netsnmp_request_group *);
  void saHpiInventoryTable_set_free (netsnmp_request_group *);
  void saHpiInventoryTable_set_undo (netsnmp_request_group *);

    saHpiInventoryTable_context
    * saHpiInventoryTable_duplicate_row (saHpiInventoryTable_context *);

    netsnmp_index
    * saHpiInventoryTable_delete_row (saHpiInventoryTable_context *);

  int
    saHpiInventoryTable_can_delete (saHpiInventoryTable_context *
				    undo_ctx,
				    saHpiInventoryTable_context *
				    row_ctx, netsnmp_request_group * rg);


    saHpiInventoryTable_context
    * saHpiInventoryTable_create_row (netsnmp_index *);


#ifdef __cplusplus
};
#endif

#endif /** SAHPIINVENTORYTABLE_H */
