/*
 * (C) Copyright IBM Corp. 2004
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   Konrad Rzeszutek <konradr@us.ibm.com>

 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.array-user.conf,v 5.18 2003/11/07 17:03:52 rstory Exp $
 *
 * $Id: saHpiSensorThdPosHysteresisTable.h,v 1.2 2004/03/02 23:23:58 konradrzeszutek Exp $
 *
 */
#ifndef SAHPISENSORTHDPOSHYSTERESISICALTABLE_H
#define SAHPISENSORTHDPOSHYSTERESISICALTABLE_H

#ifdef __cplusplus
extern "C"
{
#endif


#include <net-snmp/net-snmp-config.h>
#include <net-snmp/library/container.h>
#include <net-snmp/agent/table_array.h>
#include <SaHpi.h>
#include <hpiSubagent.h>


	/** Index saHpiDomainID is external */
	/** Index saHpiResourceID is external */
	/** Index saHpiSensorIndex is external */

  typedef struct saHpiSensorThdPosHysteresisTable_context_s
  {
    netsnmp_index index;

    /** TruthValue = ASN_INTEGER */
    long            saHpiSensorThdPosHysteresisIsReadable;
    
    /** TruthValue = ASN_INTEGER */
    long            saHpiSensorThdPosHysteresisIsWritable;
    
    /** TruthValue = ASN_INTEGER */
    long            saHpiSensorThdPosHysteresisIsFixed;
    
    /** INTEGER = ASN_INTEGER */
    long            saHpiSensorThdPosHysteresisValuesPresent;

    /** UNSIGNED32 = ASN_UNSIGNED */
    unsigned long   saHpiSensorThdPosHysteresisRaw;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char
      saHpiSensorThdPosHysteresisInterpreted[SENSOR_THD_INTER_MAX];
    size_t saHpiSensorThdPosHysteresisInterpreted_len;



    long sensor_id;
    long resource_id;
    long domain_id;
    long hash;


  } saHpiSensorThdPosHysteresisTable_context;

/*************************************************************
 * function declarations
 */

  void initialize_table_saHpiSensorThdPosHysteresisTable (void);

  int
    delete_ThdPosHysteresis_row (SaHpiDomainIdT domain_id,
			       SaHpiResourceIdT resource_id,
			       SaHpiSensorNumT num);

  int populate_ThdPosHysteresis (SaHpiDomainIdT domain_id,
			       SaHpiResourceIdT resource_id,
			       SaHpiSensorNumT sensor_id,
			       SaHpiSensorThdDefnT *threshold_def,
			       SaHpiSensorReadingT * reading);


  int set_ThdPosHysteresis (saHpiSensorThdPosHysteresisTable_context *ctx);

  int
    saHpiSensorThdPosHysteresisTable_get_value (netsnmp_request_info *,
					      netsnmp_index *,
					      netsnmp_table_request_info *);


/*************************************************************
 * oid declarations
 */
  extern oid saHpiSensorThdPosHysteresisTable_oid[];
  extern size_t saHpiSensorThdPosHysteresisTable_oid_len;

#define saHpiSensorThdPosHysteresisTable_TABLE_OID hpiSensor_OID,13

/*************************************************************
 * column number definitions for table saHpiSensorThdPosHysteresisTable
 */
#define COLUMN_SAHPISENSORTHDPOSHYSTERESISICALISREADABLE 1
#define COLUMN_SAHPISENSORTHDPOSHYSTERESISICALISWRITABLE 2
#define COLUMN_SAHPISENSORTHDPOSHYSTERESISICALISFIXED 3
#define COLUMN_SAHPISENSORTHDPOSHYSTERESISICALVALUESPRESENT 4
#define COLUMN_SAHPISENSORTHDPOSHYSTERESISICALRAW 5
#define COLUMN_SAHPISENSORTHDPOSHYSTERESISICALINTERPRETED 6
#define saHpiSensorThdPosHysteresisTable_COL_MIN 1
#define saHpiSensorThdPosHysteresisTable_COL_MAX 6

  int
    saHpiSensorThdPosHysteresisTable_extract_index
    (saHpiSensorThdPosHysteresisTable_context * ctx, netsnmp_index * hdr);

  void saHpiSensorThdPosHysteresisTable_set_reserve1 (netsnmp_request_group *);
  void saHpiSensorThdPosHysteresisTable_set_reserve2 (netsnmp_request_group *);
  void saHpiSensorThdPosHysteresisTable_set_action (netsnmp_request_group *);
  void saHpiSensorThdPosHysteresisTable_set_commit (netsnmp_request_group *);
  void saHpiSensorThdPosHysteresisTable_set_free (netsnmp_request_group *);
  void saHpiSensorThdPosHysteresisTable_set_undo (netsnmp_request_group *);

    saHpiSensorThdPosHysteresisTable_context
    * saHpiSensorThdPosHysteresisTable_duplicate_row
    (saHpiSensorThdPosHysteresisTable_context *);
    netsnmp_index
    * saHpiSensorThdPosHysteresisTable_delete_row
    (saHpiSensorThdPosHysteresisTable_context *);

  int
    saHpiSensorThdPosHysteresisTable_can_delete
    (saHpiSensorThdPosHysteresisTable_context * undo_ctx,
     saHpiSensorThdPosHysteresisTable_context * row_ctx,
     netsnmp_request_group * rg);



    saHpiSensorThdPosHysteresisTable_context
    * saHpiSensorThdPosHysteresisTable_create_row (netsnmp_index *);

#ifdef __cplusplus
};
#endif

#endif /** SAHPISENSORTHDPOSHYSTERESISICALTABLE_H */
